<?php
/**
 * Plugin Name: ShopCred
 * Plugin URI: https://exclusiveblocks.com/plugins/shopcred
 * Description: The Best Gutenberg Blocks Collection for WooCommerce from Excluisve Blocks
 * Author: ExclusiveBlocks.com
 * Author URI: https://exclusiveblocks.com/
 * Version: 1.1.2
 * License: GPL2+
 * License URI: https://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain: shopcred
 *
 * @package ShopCred
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

define( 'SPC_FILE', __FILE__ );
define( 'SPC_DIR', plugin_dir_path( SPC_FILE ) );
define( 'SPC_URL', plugins_url( '/', SPC_FILE ) );
define( 'SPC_ASSETS', plugins_url( '/assets', SPC_FILE ) );
define( 'SPC_VER', '1.1.2' );
define( 'SPC_ROOT', dirname( plugin_basename( __FILE__ ) ) );
define( 'SPC_ASSET_VER', get_option( '__spc_asset_version', SPC_VER ) );
define( 'SPC_ADMIN', SPC_DIR . 'admin/' );	
define( 'SPC_ADMIN_URL', plugins_url( '/', __FILE__ ) . 'admin/' );
define( 'SPC_PLUGIN_NAME', 'ShopCred' );

if ( ! defined( 'SPC_TABLET_BREAKPOINT' ) ) {
	define( 'SPC_TABLET_BREAKPOINT', '976' );
}
if ( ! defined( 'SPC_MOBILE_BREAKPOINT' ) ) {
	define( 'SPC_MOBILE_BREAKPOINT', '767' );
}

add_filter( 'plugin_action_links_'. plugin_basename(__FILE__), 'shopcred_insert_settings_url' );

/**
 * Extending plugin links
 *
 * @since 3.0.0
 */
function shopcred_insert_settings_url( $links ) {
	// settings
	$action_links = [ 
		'settings' => sprintf('<a href="admin.php?page=shopcred-dashboard-settings-page&subpage=shopcred-general-settings">' . __('Settings', 'shopcred') . '</a>'),
	];

	return array_merge( $action_links, $links );

}

/**
 * 
 * Plugin Redirect Option Added by register_activation_hook
 * 
 */
function spc_plugin_redirect_option() {
	add_option( 'spc_do_update_redirect', true );
}
register_activation_hook( __FILE__ , 'spc_plugin_redirect_option' );

/**
 * Admin notice
 * Warning when the site doesn't have Elementor installed or activated.
 *
 * @since 1.0.0
 *
 * @access public
 */
function spm_admin_notice_missing_woocommerce() {

	$message = sprintf(
		__( '%1$s requires %2$s to be installed and activated to function properly. %3$s', 'shopcred' ),
		'<strong>' . __( 'ShopCred', 'shopcred' ) . '</strong>',
		'<strong>' . __( 'Woocommerce', 'shopcred' ) . '</strong>',
		'<a href="' . esc_url( admin_url( 'plugin-install.php?s=Woocommerce&tab=search&type=term' ) ) . '">' . __( 'Please click here to install/activate Woocommerce', 'shopcred' ) . '</a>'
	);

	printf( '<div class="notice notice-warning is-dismissible"><p style="padding: 5px 0">%1$s</p></div>', $message );

}

/**
 * Initialize the plugin tracker
 *
 * @return void
 */
function appsero_init_tracker_shopcred() {

    if ( ! class_exists( 'Appsero\Client' ) ) {
      require_once __DIR__ . '/appsero/client/Client.php';
    }

    $client = new Appsero\Client( '3c1da7cb-634a-422a-965f-8af7494ba70b', 'ShopCred', __FILE__ );

    // Active insights
    $client->insights()->init();

}

appsero_init_tracker_shopcred();

// Initiate Plugin Base Class
require_once SPC_DIR . 'includes/base.php';
